'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _debounce = require('debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _scrollContext = require('./scrollContext');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ScrollingProvider = (_temp2 = _class = function (_React$Component) {
  _inherits(ScrollingProvider, _React$Component);

  function ScrollingProvider() {
    var _temp, _this, _ret;

    _classCallCheck(this, ScrollingProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
      selected: ''
    }, _this.refList = {}, _this.handleScroll = function () {
      var selected = Object.entries(_this.refList).reduce(function (acc, _ref) {
        var key = _ref[0],
            value = _ref[1];

        var _value$current$getBou = value.current.getBoundingClientRect(),
            top = _value$current$getBou.top;

        var differenceFromTop = Math.abs(top);

        return differenceFromTop < acc.differenceFromTop ? {
          differenceFromTop: differenceFromTop,
          key: key
        } : acc;
      }, {
        differenceFromTop: 9999,
        key: ''
      });

      _this.setState({ selected: selected.key });
    }, _this.debounceScroll = (0, _debounce2.default)(_this.handleScroll, _this.props.debounceDelay || 50), _this.registerRef = function (id) {
      var _extends2;

      var newRef = _react2.default.createRef();
      _this.refList = _extends({}, _this.refList, (_extends2 = {}, _extends2[id] = newRef, _extends2));
      return newRef;
    }, _this.scrollTo = function (section) {
      var behavior = _this.props.scrollBehavior;

      var sectionRef = _this.refList[section];
      if (!sectionRef) return console.warn('Section ID not recognized!');

      var top = sectionRef.current.offsetTop;

      _this.setState({ selected: section }, function () {
        return window.scrollTo({
          top: top,
          behavior: behavior
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ScrollingProvider.prototype.componentDidMount = function componentDidMount() {
    document.addEventListener('scroll', this.debounceScroll, true);
    this.handleScroll();
  };

  ScrollingProvider.prototype.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('scroll', this.debounceScroll, true);
  };

  // eslint-disable-next-line


  ScrollingProvider.prototype.render = function render() {
    var selected = this.state.selected;
    var children = this.props.children;

    var value = {
      registerRef: this.registerRef,
      scrollTo: this.scrollTo,
      selected: selected
    };
    return _react2.default.createElement(
      _scrollContext.Provider,
      { value: value },
      children
    );
  };

  return ScrollingProvider;
}(_react2.default.Component), _class.defaultProps = {
  debounceDelay: 50,
  scrollBehavior: 'smooth',
  children: null
}, _temp2);
exports.default = ScrollingProvider;
ScrollingProvider.propTypes = process.env.NODE_ENV !== "production" ? {
  /** ms. to wait until the calculation of the current section */
  debounceDelay: _propTypes2.default.number,
  /** scrolling style */
  scrollBehavior: _propTypes2.default.oneOf(['auto', 'smooth']),
  /** React component */
  children: _propTypes2.default.node
} : {};
module.exports = exports['default'];