'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _scrollContext = require('./scrollContext');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SectionLink = function SectionLink(_ref) {
  var section = _ref.section,
      children = _ref.children;
  return _react2.default.createElement(
    _scrollContext.Consumer,
    null,
    function (_ref2) {
      var scrollTo = _ref2.scrollTo,
          selected = _ref2.selected;

      var onClick = function onClick() {
        return scrollTo(section);
      };
      var isSelected = selected === section;
      return children({ onClick: onClick, isSelected: isSelected });
    }
  );
};

SectionLink.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Section ID */
  section: _propTypes2.default.string.isRequired,
  /** renderProp */
  children: _propTypes2.default.func.isRequired
} : {};

exports.default = SectionLink;
module.exports = exports['default'];